diff --git a/src/responder/pam/pamsrv_cmd.c b/src/responder/pam/pamsrv_cmd.c
index b9fd353259834910e85b05f8e5aa20c9c5674501..c58042b29d1a0fe5c1b453d43eb58cd4ff61fbe6 100644
--- a/src/responder/pam/pamsrv_cmd.c
+++ b/src/responder/pam/pamsrv_cmd.c
@@ -586,6 +586,7 @@ static void pam_handle_cached_login(struct pam_auth_req *preq, int ret,
 static void pam_reply(struct pam_auth_req *preq)
 {
     struct cli_ctx *cctx;
+    struct cli_protocol *prctx;
     uint8_t *body;
     size_t blen;
     int ret;
@@ -606,6 +607,7 @@ static void pam_reply(struct pam_auth_req *preq)
     pd = preq->pd;
     cctx = preq->cctx;
     pctx = talloc_get_type(preq->cctx->rctx->pvt_ctx, struct pam_ctx);
+    prctx = talloc_get_type(cctx->protocol_ctx, struct cli_protocol);
 
     ret = confdb_get_int(pctx->rctx->cdb, CONFDB_PAM_CONF_ENTRY,
                          CONFDB_PAM_VERBOSITY, DEFAULT_PAM_VERBOSITY,
@@ -738,8 +740,8 @@ static void pam_reply(struct pam_auth_req *preq)
         return;
     }
 
-    ret = sss_packet_new(cctx->creq, 0, sss_packet_get_cmd(cctx->creq->in),
-                         &cctx->creq->out);
+    ret = sss_packet_new(prctx->creq, 0, sss_packet_get_cmd(prctx->creq->in),
+                         &prctx->creq->out);
     if (ret != EOK) {
         goto done;
     }
@@ -790,7 +792,7 @@ static void pam_reply(struct pam_auth_req *preq)
         resp = resp->next;
     }
 
-    ret = sss_packet_grow(cctx->creq->out, sizeof(int32_t) +
+    ret = sss_packet_grow(prctx->creq->out, sizeof(int32_t) +
                                            sizeof(int32_t) +
                                            resp_c * 2* sizeof(int32_t) +
                                            resp_size);
@@ -798,7 +800,7 @@ static void pam_reply(struct pam_auth_req *preq)
         goto done;
     }
 
-    sss_packet_get_body(cctx->creq->out, &body, &blen);
+    sss_packet_get_body(prctx->creq->out, &body, &blen);
     DEBUG(SSSDBG_FUNC_DATA, "blen: %zu\n", blen);
     p = 0;
 
@@ -913,12 +915,15 @@ static int pam_check_user_done(struct pam_auth_req *preq, int ret);
 
 static errno_t pam_forwarder_parse_data(struct cli_ctx *cctx, struct pam_data *pd)
 {
+    struct cli_protocol *prctx;
     uint8_t *body;
     size_t blen;
     errno_t ret;
     uint32_t terminator;
 
-    sss_packet_get_body(cctx->creq->in, &body, &blen);
+    prctx = talloc_get_type(cctx->protocol_ctx, struct cli_protocol);
+
+    sss_packet_get_body(prctx->creq->in, &body, &blen);
     if (blen >= sizeof(uint32_t)) {
         SAFEALIGN_COPY_UINT32(&terminator,
                               body + blen - sizeof(uint32_t),
@@ -930,7 +935,7 @@ static errno_t pam_forwarder_parse_data(struct cli_ctx *cctx, struct pam_data *p
         }
     }
 
-    switch (cctx->cli_protocol_version->version) {
+    switch (prctx->cli_protocol_version->version) {
         case 1:
             ret = pam_parse_in_data(pd, body, blen);
             break;
@@ -942,7 +947,7 @@ static errno_t pam_forwarder_parse_data(struct cli_ctx *cctx, struct pam_data *p
             break;
         default:
             DEBUG(SSSDBG_CRIT_FAILURE, "Illegal protocol version [%d].\n",
-                      cctx->cli_protocol_version->version);
+                      prctx->cli_protocol_version->version);
             ret = EINVAL;
     }
     if (ret != EOK) {
diff --git a/src/responder/ssh/sshsrv.c b/src/responder/ssh/sshsrv.c
index d4e202d87f520f1bdcd521733592027773a821d6..091753f72777ccd1225de083382c7d6c685aa868 100644
--- a/src/responder/ssh/sshsrv.c
+++ b/src/responder/ssh/sshsrv.c
@@ -99,6 +99,7 @@ int ssh_process_init(TALLOC_CTX *mem_ctx,
                            &monitor_ssh_methods,
                            "SSH",
                            &ssh_dp_methods.vtable,
+                           sss_connection_setup,
                            &rctx);
     if (ret != EOK) {
         DEBUG(SSSDBG_FATAL_FAILURE, "sss_process_init() failed\n");
diff --git a/src/responder/ssh/sshsrv_cmd.c b/src/responder/ssh/sshsrv_cmd.c
index af385fde8b382da513dbac29f496462a90c4c269..b95fc952f5187f9bf1a6b2a43cb449275bae80e2 100644
--- a/src/responder/ssh/sshsrv_cmd.c
+++ b/src/responder/ssh/sshsrv_cmd.c
@@ -662,9 +662,8 @@ done:
 static errno_t
 ssh_cmd_parse_request(struct ssh_cmd_ctx *cmd_ctx)
 {
-    struct cli_ctx *cctx = cmd_ctx->cctx;
-    struct ssh_ctx *ssh_ctx = talloc_get_type(cctx->rctx->pvt_ctx,
-                                              struct ssh_ctx);
+    struct cli_protocol *pctx;
+    struct ssh_ctx *ssh_ctx;
     errno_t ret;
     uint8_t *body;
     size_t body_len;
@@ -677,7 +676,10 @@ ssh_cmd_parse_request(struct ssh_cmd_ctx *cmd_ctx)
     uint32_t domain_len;
     char *domain = NULL;
 
-    sss_packet_get_body(cctx->creq->in, &body, &body_len);
+    ssh_ctx = talloc_get_type(cmd_ctx->cctx->rctx->pvt_ctx, struct ssh_ctx);
+    pctx = talloc_get_type(cmd_ctx->cctx->protocol_ctx, struct cli_protocol);
+
+    sss_packet_get_body(pctx->creq->in, &body, &body_len);
 
     SAFEALIGN_COPY_UINT32_CHECK(&flags, body+c, body_len, &c);
     if (flags & ~(uint32_t)SSS_SSH_REQ_MASK) {
@@ -752,7 +754,8 @@ ssh_cmd_parse_request(struct ssh_cmd_ctx *cmd_ctx)
         DEBUG(SSSDBG_TRACE_FUNC,
               "Parsing name [%s][%s]\n", name, domain ? domain : "<ALL>");
 
-        ret = sss_parse_name_for_domains(cmd_ctx, cctx->rctx->domains,
+        ret = sss_parse_name_for_domains(cmd_ctx,
+                                         cmd_ctx->cctx->rctx->domains,
                                          domain, name,
                                          &cmd_ctx->domname,
                                          &cmd_ctx->name);
@@ -789,7 +792,7 @@ static errno_t decode_and_add_base64_data(struct ssh_cmd_ctx *cmd_ctx,
                                           const char *fqname,
                                           size_t *c)
 {
-    struct cli_ctx *cctx = cmd_ctx->cctx;
+    struct cli_protocol *pctx;
     uint8_t *key;
     size_t key_len;
     uint8_t *body;
@@ -811,10 +814,12 @@ static errno_t decode_and_add_base64_data(struct ssh_cmd_ctx *cmd_ctx,
         return ENOMEM;
     }
 
+    pctx = talloc_get_type(cmd_ctx->cctx->protocol_ctx, struct cli_protocol);
+
     for (d = 0; d < el->num_values; d++) {
         if (cert_data) {
 
-            ret = confdb_get_string(cctx->rctx->cdb, tmp_ctx,
+            ret = confdb_get_string(cmd_ctx->cctx->rctx->cdb, tmp_ctx,
                                     CONFDB_MONITOR_CONF_ENTRY,
                                     CONFDB_MONITOR_CERT_VERIFICATION, NULL,
                                     &cert_verification_opts);
@@ -851,13 +856,13 @@ static errno_t decode_and_add_base64_data(struct ssh_cmd_ctx *cmd_ctx,
             }
         }
 
-        ret = sss_packet_grow(cctx->creq->out,
+        ret = sss_packet_grow(pctx->creq->out,
                               3*sizeof(uint32_t) + key_len + fqname_len);
         if (ret != EOK) {
             DEBUG(SSSDBG_OP_FAILURE, "sss_packet_grow failed.\n");
             goto done;
         }
-        sss_packet_get_body(cctx->creq->out, &body, &body_len);
+        sss_packet_get_body(pctx->creq->out, &body, &body_len);
 
         SAFEALIGN_SET_UINT32(body+(*c), 0, c);
         SAFEALIGN_SET_UINT32(body+(*c), fqname_len, c);
@@ -878,7 +883,6 @@ done:
 static errno_t
 ssh_cmd_build_reply(struct ssh_cmd_ctx *cmd_ctx)
 {
-    struct cli_ctx *cctx = cmd_ctx->cctx;
     errno_t ret;
     uint8_t *body;
     size_t body_len;
@@ -891,12 +895,15 @@ ssh_cmd_build_reply(struct ssh_cmd_ctx *cmd_ctx)
     const char *name;
     char *fqname;
     uint32_t fqname_len;
-    struct ssh_ctx *ssh_ctx = talloc_get_type(cctx->rctx->pvt_ctx,
-                                              struct ssh_ctx);
+    struct ssh_ctx *ssh_ctx;
+    struct cli_protocol *pctx;
 
-    ret = sss_packet_new(cctx->creq, 0,
-                         sss_packet_get_cmd(cctx->creq->in),
-                         &cctx->creq->out);
+    ssh_ctx = talloc_get_type(cmd_ctx->cctx->rctx->pvt_ctx, struct ssh_ctx);
+    pctx = talloc_get_type(cmd_ctx->cctx->protocol_ctx, struct cli_protocol);
+
+    ret = sss_packet_new(pctx->creq, 0,
+                         sss_packet_get_cmd(pctx->creq->in),
+                         &pctx->creq->out);
     if (ret != EOK) {
         return ret;
     }
@@ -926,11 +933,11 @@ ssh_cmd_build_reply(struct ssh_cmd_ctx *cmd_ctx)
         count += el_user_cert->num_values;
     }
 
-    ret = sss_packet_grow(cctx->creq->out, 2*sizeof(uint32_t));
+    ret = sss_packet_grow(pctx->creq->out, 2*sizeof(uint32_t));
     if (ret != EOK) {
         return ret;
     }
-    sss_packet_get_body(cctx->creq->out, &body, &body_len);
+    sss_packet_get_body(pctx->creq->out, &body, &body_len);
 
     SAFEALIGN_SET_UINT32(body+c, count, &c);
     SAFEALIGN_SET_UINT32(body+c, 0, &c);
@@ -1006,17 +1013,19 @@ ssh_cmd_send_error(struct ssh_cmd_ctx *cmd_ctx,
 static errno_t
 ssh_cmd_send_reply(struct ssh_cmd_ctx *cmd_ctx)
 {
-    struct cli_ctx *cctx = cmd_ctx->cctx;
+    struct cli_protocol *pctx;
     errno_t ret;
 
+    pctx = talloc_get_type(cmd_ctx->cctx->protocol_ctx, struct cli_protocol);
+
     /* create response packet */
     ret = ssh_cmd_build_reply(cmd_ctx);
     if (ret != EOK) {
         return ret;
     }
 
-    sss_packet_set_error(cctx->creq->out, EOK);
-    sss_cmd_done(cctx, cmd_ctx);
+    sss_packet_set_error(pctx->creq->out, EOK);
+    sss_cmd_done(cmd_ctx->cctx, cmd_ctx);
 
     return EOK;
 }
diff --git a/src/responder/sudo/sudosrv.c b/src/responder/sudo/sudosrv.c
index ff5d92e7005db9f6e883c78cf1a6218e9a150e0a..6d46418d8bcd9ab443d3fe4a0a2734a9e6df5042 100644
--- a/src/responder/sudo/sudosrv.c
+++ b/src/responder/sudo/sudosrv.c
@@ -101,6 +101,7 @@ int sudo_process_init(TALLOC_CTX *mem_ctx,
                            &monitor_sudo_methods,
                            "SUDO",
                            &sudo_dp_methods.vtable,
+                           sss_connection_setup,
                            &rctx);
     if (ret != EOK) {
         DEBUG(SSSDBG_FATAL_FAILURE, "sss_process_init() failed\n");
diff --git a/src/responder/sudo/sudosrv_cmd.c b/src/responder/sudo/sudosrv_cmd.c
index dd636e949200dd49c1422a5789e9328dc4b25fb0..c78dcb830ed7d1ff95eb2d5e52e5c45a222a16e3 100644
--- a/src/responder/sudo/sudosrv_cmd.c
+++ b/src/responder/sudo/sudosrv_cmd.c
@@ -38,14 +38,17 @@ static errno_t sudosrv_cmd_send_reply(struct sudo_cmd_ctx *cmd_ctx,
     uint8_t *packet_body = NULL;
     size_t packet_len = 0;
     struct cli_ctx *cli_ctx = cmd_ctx->cli_ctx;
+    struct cli_protocol *pctx;
     TALLOC_CTX *tmp_ctx;
 
     tmp_ctx = talloc_new(NULL);
     if (!tmp_ctx) return ENOMEM;
 
-    ret = sss_packet_new(cli_ctx->creq, 0,
-                         sss_packet_get_cmd(cli_ctx->creq->in),
-                         &cli_ctx->creq->out);
+    pctx = talloc_get_type(cli_ctx->protocol_ctx, struct cli_protocol);
+
+    ret = sss_packet_new(pctx->creq, 0,
+                         sss_packet_get_cmd(pctx->creq->in),
+                         &pctx->creq->out);
     if (ret != EOK) {
         DEBUG(SSSDBG_CRIT_FAILURE,
               "Unable to create a new packet [%d]; %s\n",
@@ -53,16 +56,16 @@ static errno_t sudosrv_cmd_send_reply(struct sudo_cmd_ctx *cmd_ctx,
         goto done;
     }
 
-    ret = sss_packet_grow(cli_ctx->creq->out, response_len);
+    ret = sss_packet_grow(pctx->creq->out, response_len);
     if (ret != EOK) {
         DEBUG(SSSDBG_CRIT_FAILURE,
               "Unable to create response: %s\n", strerror(ret));
         goto done;
     }
-    sss_packet_get_body(cli_ctx->creq->out, &packet_body, &packet_len);
+    sss_packet_get_body(pctx->creq->out, &packet_body, &packet_len);
     memcpy(packet_body, response_body, response_len);
 
-    sss_packet_set_error(cli_ctx->creq->out, EOK);
+    sss_packet_set_error(pctx->creq->out, EOK);
     sss_cmd_done(cmd_ctx->cli_ctx, cmd_ctx);
 
     ret = EOK;
@@ -172,7 +175,8 @@ static int sudosrv_cmd(enum sss_sudo_type type, struct cli_ctx *cli_ctx)
     struct sudo_cmd_ctx *cmd_ctx = NULL;
     uint8_t *query_body = NULL;
     size_t query_len = 0;
-    uint32_t protocol = cli_ctx->cli_protocol_version->version;
+    struct cli_protocol *pctx;
+    uint32_t protocol;
     errno_t ret;
 
     /* create cmd_ctx */
@@ -193,6 +197,9 @@ static int sudosrv_cmd(enum sss_sudo_type type, struct cli_ctx *cli_ctx)
         return EFAULT;
     }
 
+    pctx = talloc_get_type(cli_ctx->protocol_ctx, struct cli_protocol);
+    protocol = pctx->cli_protocol_version->version;
+
     /* if protocol is invalid return */
     switch (protocol) {
     case 0:
@@ -214,7 +221,7 @@ static int sudosrv_cmd(enum sss_sudo_type type, struct cli_ctx *cli_ctx)
 
     /* parse query */
 
-    sss_packet_get_body(cli_ctx->creq->in, &query_body, &query_len);
+    sss_packet_get_body(pctx->creq->in, &query_body, &query_len);
     if (query_len <= 0 || query_body == NULL) {
         DEBUG(SSSDBG_CRIT_FAILURE, "Query is empty\n");
         ret = EINVAL;
diff --git a/src/tests/cmocka/common_mock_resp.c b/src/tests/cmocka/common_mock_resp.c
index 767d4d7e1455d0998e6511cefa595ec6238ba07d..4460bc03f2f961f5d5688c5c48ac1de8bb6ccf6d 100644
--- a/src/tests/cmocka/common_mock_resp.c
+++ b/src/tests/cmocka/common_mock_resp.c
@@ -57,12 +57,23 @@ mock_cctx(TALLOC_CTX *mem_ctx, struct resp_ctx *rctx)
     cctx = talloc_zero(mem_ctx, struct cli_ctx);
     if (!cctx) return NULL;
 
-    cctx->creq = talloc_zero(cctx, struct cli_request);
-    if (cctx->creq == NULL) {
-        talloc_free(cctx);
-        return NULL;
-    }
-
     cctx->rctx = rctx;
     return cctx;
 }
+
+struct cli_protocol *
+mock_prctx(TALLOC_CTX *mem_ctx)
+{
+    struct cli_protocol *prctx;
+
+    prctx = talloc_zero(mem_ctx, struct cli_protocol);
+    if (!prctx) return NULL;
+
+    prctx->creq = talloc_zero(prctx, struct cli_request);
+    if (prctx->creq == NULL) {
+        talloc_free(prctx);
+        return NULL;
+    }
+
+    return prctx;
+}
diff --git a/src/tests/cmocka/common_mock_resp.h b/src/tests/cmocka/common_mock_resp.h
index a4d8f55c701ee0c2fa6f0b9d8c34fdaf518a95a9..aab6a94e42f3e754bb6f4f4b2fc1b990658e35f9 100644
--- a/src/tests/cmocka/common_mock_resp.h
+++ b/src/tests/cmocka/common_mock_resp.h
@@ -38,6 +38,9 @@ mock_rctx(TALLOC_CTX *mem_ctx,
 struct cli_ctx *
 mock_cctx(TALLOC_CTX *mem_ctx, struct resp_ctx *rctx);
 
+struct cli_protocol *
+mock_prctx(TALLOC_CTX *mem_ctx);
+
 /* When mocking a module that calls sss_dp_get_account_{send,recv}
  * requests, your test, when linked against this module, will call
  * the mock functions instead. Then you can simulate results of the
diff --git a/src/tests/cmocka/test_nss_srv.c b/src/tests/cmocka/test_nss_srv.c
index f05b55e461d9a058a4894800b2efae3417c8dc01..29868a6ca84af35f1fdb016437b7941b39ae33c8 100644
--- a/src/tests/cmocka/test_nss_srv.c
+++ b/src/tests/cmocka/test_nss_srv.c
@@ -124,13 +124,17 @@ static void set_cmd_cb(cmd_cb_fn_t fn)
 
 void __wrap_sss_cmd_done(struct cli_ctx *cctx, void *freectx)
 {
-    struct sss_packet *packet = cctx->creq->out;
+    struct cli_protocol *pctx;
+    struct sss_packet *packet;
     uint8_t *body;
     size_t blen;
     cmd_cb_fn_t check_cb;
 
     check_cb = sss_mock_ptr_type(cmd_cb_fn_t);
 
+    pctx = talloc_get_type(cctx->protocol_ctx, struct cli_protocol);
+    packet = pctx->creq->out;
+
     __real_sss_packet_get_body(packet, &body, &blen);
 
     nss_test_ctx->tctx->error = check_cb(sss_packet_get_status(packet),
@@ -1060,6 +1064,15 @@ void test_nss_setup(struct sss_test_conf_param params[],
     /* Create client context */
     nss_test_ctx->cctx = mock_cctx(nss_test_ctx, nss_test_ctx->rctx);
     assert_non_null(nss_test_ctx->cctx);
+
+    /* Add nss specific state_ctx */
+    nss_connection_setup(nss_test_ctx->cctx);
+    assert_non_null(nss_test_ctx->cctx->state_ctx);
+
+    /* do after previous setup as the former nulls procotol_ctx */
+    nss_test_ctx->cctx->protocol_ctx = mock_prctx(nss_test_ctx->cctx);
+    assert_non_null(nss_test_ctx->cctx->protocol_ctx);
+
 }
 
 static int test_nss_getgrnam_check(struct group *expected, struct group *gr, const int nmem)
diff --git a/src/tests/cmocka/test_pam_srv.c b/src/tests/cmocka/test_pam_srv.c
index 75411feeefb02cfbb9d5eb19b1082f6445d92a66..c9cdb031f304167242c9142a3bb3237db689a99e 100644
--- a/src/tests/cmocka/test_pam_srv.c
+++ b/src/tests/cmocka/test_pam_srv.c
@@ -222,6 +222,7 @@ void test_pam_setup(struct sss_test_conf_param dom_params[],
                     struct sss_test_conf_param monitor_params[],
                     void **state)
 {
+    struct cli_protocol *prctx;
     errno_t ret;
 
     pam_test_ctx = talloc_zero(NULL, struct pam_test_ctx);
@@ -261,9 +262,12 @@ void test_pam_setup(struct sss_test_conf_param dom_params[],
     /* Create client context */
     pam_test_ctx->cctx = mock_cctx(pam_test_ctx, pam_test_ctx->rctx);
     assert_non_null(pam_test_ctx->cctx);
-
-    pam_test_ctx->cctx->cli_protocol_version = register_cli_protocol_version();
     pam_test_ctx->cctx->ev = pam_test_ctx->tctx->ev;
+
+    prctx = mock_prctx(pam_test_ctx->cctx);
+    assert_non_null(prctx);
+    pam_test_ctx->cctx->protocol_ctx = prctx;
+    prctx->cli_protocol_version = register_cli_protocol_version();
 }
 
 static void pam_test_setup_common(void)
@@ -397,11 +401,14 @@ void __real_sss_packet_get_body(struct sss_packet *packet,
 
 void __wrap_sss_cmd_done(struct cli_ctx *cctx, void *freectx)
 {
-    struct sss_packet *packet = cctx->creq->out;
+    struct cli_protocol *prctx;
+    struct sss_packet *packet;
     uint8_t *body;
     size_t blen;
     cmd_cb_fn_t check_cb;
 
+    prctx = talloc_get_type(cctx->protocol_ctx, struct cli_protocol);
+    packet = prctx->creq->out;
     assert_non_null(packet);
 
     check_cb = sss_mock_ptr_type(cmd_cb_fn_t);
-- 
2.5.0

